package es.ua.j2ee.alarma;

import java.util.*;

import javax.microedition.io.PushRegistry;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

public class FormularioAlarma extends Form implements CommandListener {
	Command cmdFijar;

	Timer temp = null;

	MIDlet owner;

	DateField fecha;
	StringItem estado;

	public FormularioAlarma(MIDlet owner) {
		super("Alarma");
		
		this.owner = owner;
		
		// Crea campos
		fecha = new DateField("Hora alarma: ", DateField.DATE_TIME);
		fecha.setDate(new Date());
		estado = new StringItem("Estado: ", "Desactivada");

		this.append(fecha);
		this.append(estado);

		// Crea comandos
		cmdFijar = new Command("Fijar alarma", Command.ITEM, 1);
		this.addCommand(cmdFijar);
		this.setCommandListener(this); 
	}

	public void commandAction(Command cmd, Displayable d) {
		if(cmd == cmdFijar) {
			Thread t = new Thread() {
				public void run() {
					// Alarma push
					String midletName = owner.getClass().getName();
					try {
						PushRegistry.registerAlarm(midletName, fecha.getDate().getTime());
						estado.setText("Activada");
					} catch(Exception e) {
						System.out.println("Excepcion en push: " + e.getMessage());
					}					
				}
			};
			t.start();
		}
	}	
}
